/*
 * n01_stats
 *
 * ListView.h
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

#ifndef _INC_LISTVIEW_H
#define _INC_LISTVIEW_H

/* Include Files */
#include <commctrl.h>

/* Define */
#define WM_LV_EVENT			(WM_APP + 1)
#define MAX_HEADER			50

/* Struct */
typedef struct _HEADER_INFO {
	int show;
	int order;

	int type;
	int fmt;
	int cx;
} HEADER_INFO;

/* Function Prototypes */
HWND listview_create(const HINSTANCE hInstance, const HWND hWnd, const int id, const HIMAGELIST icon_list);
void listview_close(const HWND hListView);
LRESULT listview_notify_proc(const HWND hWnd, const HWND hListView, const LPARAM lParam);
LRESULT listview_header_notify_proc(const HWND hWnd, const HWND hListView, const LPARAM lParam);
void listview_sort(const HWND hListView, int colum, int order);
BOOL listview_set_column(const HWND hListView, HEADER_INFO *hi, const int hi_count);
BOOL listview_set_lparam(const HWND hListView, const int i, const LPARAM lParam);
LPARAM listview_get_lparam(const HWND hListView, const int i);
int listview_set_item(const HWND hListView, const int i, const LPARAM lParam);
BOOL listview_get_disp_item(const HWND hListView, LV_DISPINFO *lv_disp);
int CALLBACK listview_compare_func(LPARAM lParam1, LPARAM lParam2, LPARAM colum);

#endif
/* End of source */
