/*
 * n01_stats
 *
 * ToolBar.c
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef	_INC_OLE
#include <commctrl.h>

#include "General.h"
#include "Ini.h"

#include "resource.h"

/* Define */
#define BITMAP_CNT						4

#define TOOLBAR_INDENT					5

#define TBICONSIZE_X					16
#define TBICONSIZE_Y					16

/* Global Variables */
static TBBUTTON tbb[] = {
	{1,	ID_MENUITEM_VIEW_NAME,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
	{2,	ID_MENUITEM_VIEW_DATE,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
	{3,	ID_MENUITEM_VIEW_ALL,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
	{0,	0,							0,					TBSTYLE_SEP,	0, 0, 0, -1},
	{0,	ID_MENUITEM_VIEW_REFRESH,	TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
};

/* Local Function Prototypes */

/*
 * toolbar_create - c[o[̍쐬
 */
HWND toolbar_create(const HINSTANCE hInst, const HWND hWnd, const int id)
{
	HWND hToolBar;

	hToolBar = CreateToolbarEx(hWnd, WS_CHILD | TBSTYLE_TOOLTIPS,
		id, BITMAP_CNT, hInst, IDR_TOOLBAR, tbb, sizeof(tbb) / sizeof(TBBUTTON), 0, 0,
		TBICONSIZE_X, TBICONSIZE_Y, sizeof(TBBUTTON));

	SetWindowLong(hToolBar, GWL_STYLE, GetWindowLong(hToolBar, GWL_STYLE) | TBSTYLE_FLAT);
	SendMessage(hToolBar, TB_SETINDENT, TOOLBAR_INDENT, 0);

	ShowWindow(hToolBar, SW_SHOW);
	return hToolBar;
}
/* End of source */
