/*
 * n01_stats
 *
 * TreeView.h
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

#ifndef _INC_TREEVIEW_H
#define _INC_TREEVIEW_H

/* Include Files */
#include <commctrl.h>

/* Define */
#define WM_TV_EVENT						(WM_APP + 2)

#define NODE_TYPE_NAME					0
#define NODE_TYPE_DATE					1

/* Struct */
typedef struct _NODE_INFO {
	UINT hash;
	int sub_type;
	TCHAR name[256];
	SYSTEMTIME date;
} NODE_INFO;

/* Function Prototypes */
HWND treeview_create(const HINSTANCE hInstance, const HWND hWnd, const int id, const HIMAGELIST icon_list);
void treeview_close(const HWND hTreeView);
LRESULT treeview_notify_proc(const HWND hWnd, LPARAM lParam);
void treeview_scroll(const HWND hTreeView);
HTREEITEM treeview_set_item(const HWND hTreeView, TCHAR *buf, const HTREEITEM hParent, const HTREEITEM After,
							const int icon, const int select_icon, LPARAM lParam);
void treeview_delete_child(const HWND hTreeView, const HTREEITEM parent_item);
BOOL treeview_set_text(const HWND hTreeView, const HTREEITEM hItem, TCHAR *text);
BOOL treeview_get_text(const HWND hTreeView, const HTREEITEM hItem, TCHAR *text);
BOOL treeview_set_icon(const HWND hTreeView, const HTREEITEM hItem, const int icon, const int select_icon);
int treeview_get_icon(const HWND hTreeView, const HTREEITEM hItem);
BOOL treeview_set_lparam(const HWND hTreeView, const HTREEITEM hItem, const LPARAM lParam);
LPARAM treeview_get_lparam(const HWND hTreeView, const HTREEITEM hItem);
HTREEITEM treeview_lparam_to_item(const HWND hTreeView, const HTREEITEM hParent, const LPARAM lParam);
HTREEITEM treeview_get_rootitem(const HWND hTreeView, const HTREEITEM hItem);
HTREEITEM treeview_get_hitest(const HWND hTreeView);

BOOL treeview_add_node_name(const HWND hTreeView, HTREEITEM hRoot, TCHAR *name);
UINT treeview_get_node_name(const HWND hTreeView, const HTREEITEM hItem, TCHAR *name);
BOOL treeview_add_node_date(const HWND hTreeView, HTREEITEM hRoot, const SYSTEMTIME *date);
BOOL treeview_get_node_date(const HWND hTreeView, const HTREEITEM hItem, SYSTEMTIME *date);
BOOL treeview_add_node_all(const HWND hTreeView, HTREEITEM hRoot);
BOOL treeview_get_node_info(const HWND hTreeView, const HTREEITEM get_item, EXTRACT_INFO *exi);
void treeview_free_node_info(const HWND hTreeView, const HTREEITEM hParent);

#endif
/* End of source */
