/*
 * n01_stats
 *
 * column.c
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <commctrl.h>

#include "General.h"
#include "Message.h"
#include "ListView.h"
#include "data.h"

#include "resource.h"

/* Define */
#ifndef ListView_SetCheckState
#define ListView_SetCheckState(hwndLV, i, fCheck) \
			ListView_SetItemState(hwndLV, i, \
			INDEXTOSTATEIMAGEMASK((fCheck)+1), LVIS_STATEIMAGEMASK)
#endif

/* Global Variables */
OPTION op;

/* Local Function Prototypes */
static BOOL CALLBACK column_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

/*
 * listview_move_item - Xgr[̃ACeړ
 */
void listview_move_item(const HWND hListView, int index, const int Move)
{
	HWND header_wnd;
	LV_ITEM lvi;
	TCHAR buf[10][BUF_SIZE];
	int column_cnt;
	int i = 0;
	int check;
	LPARAM lp;

	// LPARAM̎擾
	lp = listview_get_lparam(hListView, index);
	check = ListView_GetCheckState(hListView, index);

	// wb_̎擾
	if ((header_wnd = ListView_GetHeader(hListView)) == NULL) {
		header_wnd = GetWindow(hListView, GW_CHILD);
	}
	// eLXg̎擾
	column_cnt = Header_GetItemCount(header_wnd);
	for (i = 0; i < column_cnt; i++) {
		*(*(buf + i)) = TEXT('\0');
		ListView_GetItemText(hListView, index, i, *(buf + i), BUF_SIZE - 1);
	}
	// ACe̍폜
	ListView_DeleteItem(hListView, index);

	index += Move;

	// ړɃACeǉ
	lvi.mask = LVIF_TEXT | LVIF_PARAM;
	lvi.iItem = index;
	lvi.iSubItem = 0;
	lvi.pszText = *buf;
	lvi.cchTextMax = BUF_SIZE - 1;
	lvi.lParam = lp;
	i = ListView_InsertItem(hListView, &lvi);
	for (i = 1; i < column_cnt; i++) {
		ListView_SetItemText(hListView, index, i, *(buf + i));
	}
	ListView_SetCheckState(hListView, index, check);
	ListView_SetItemState(hListView, index,
		LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED);
	ListView_EnsureVisible(hListView, index, TRUE);
}

/*
 * compare - \[g
 */
static int __cdecl compare(const void *arg1, const void *arg2)
{
   return (((HEADER_INFO *)arg1)->order - ((HEADER_INFO *)arg2)->order);
}

/*
 * column_proc - EBhEvV[W
 */
static BOOL CALLBACK column_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	HEADER_INFO *wk_hi;
	LV_COLUMN lvc;
	LV_ITEM lvi;
	int i, j;
	BOOL enable;
	BOOL show_flag;

	switch (msg) {
	case WM_INITDIALOG:
		SendDlgItemMessage(hDlg, IDC_LIST_COLUMN, LVM_SETEXTENDEDLISTVIEWSTYLE, 0,
			LVS_EX_CHECKBOXES |
			SendDlgItemMessage(hDlg, IDC_LIST_COLUMN, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0));

		lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT;
		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 200;
		lvc.pszText = TEXT("");
		lvc.iSubItem = 0;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_COLUMN), lvc.iSubItem, &lvc);

		qsort(&op.hi, op.hi_count, sizeof(HEADER_INFO), compare);
		for (i = 0; i < op.hi_count; i++) {
			lvi.mask = LVIF_TEXT | LVIF_PARAM;
			lvi.iItem = ListView_GetItemCount(GetDlgItem(hDlg, IDC_LIST_COLUMN));
			lvi.iSubItem = 0;
			lvi.pszText = data_get_title(op.hi[i].type);
			lvi.cchTextMax = BUF_SIZE - 1;
			lvi.iImage = 0;
			lvi.lParam = (LPARAM)&op.hi[i];
			j = ListView_InsertItem(GetDlgItem(hDlg, IDC_LIST_COLUMN), &lvi);
			ListView_SetCheckState(GetDlgItem(hDlg, IDC_LIST_COLUMN), j, op.hi[i].show);
		}
		ListView_SetItemState(GetDlgItem(hDlg, IDC_LIST_COLUMN), 0, LVIS_FOCUSED | LVNI_SELECTED, LVIS_FOCUSED | LVNI_SELECTED);
		SendMessage(hDlg, WM_LV_EVENT, LVN_ITEMCHANGED, 0);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_NOTIFY:
		if (((NMHDR *)lParam)->hwndFrom == GetDlgItem(hDlg, IDC_LIST_COLUMN)) {
			return listview_notify_proc(hDlg, GetDlgItem(hDlg, IDC_LIST_COLUMN), lParam);
		}
		break;

	case WM_LV_EVENT:
		switch (wParam) {
		case LVN_ITEMCHANGED:
			enable = (ListView_GetSelectedCount(GetDlgItem(hDlg, IDC_LIST_COLUMN)) <= 0) ? FALSE : TRUE;
			EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_UP), enable);
			EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_DOWN), enable);
			EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_SHOW), enable);
			EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_HIDE), enable);
			break;
		}
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_BUTTON_UP:
			if ((i = ListView_GetNextItem(GetDlgItem(hDlg, IDC_LIST_COLUMN), -1, LVNI_SELECTED)) == -1) {
				break;
			}
			if (i == 0) {
				break;
			}
			listview_move_item(GetDlgItem(hDlg, IDC_LIST_COLUMN), i, -1);
			SetFocus(GetDlgItem(hDlg, IDC_LIST_COLUMN));
			break;

		case IDC_BUTTON_DOWN:
			if ((i = ListView_GetNextItem(GetDlgItem(hDlg, IDC_LIST_COLUMN), -1, LVNI_SELECTED)) == -1) {
				break;
			}
			if (i == ListView_GetItemCount(GetDlgItem(hDlg, IDC_LIST_COLUMN)) - 1) {
				break;
			}
			listview_move_item(GetDlgItem(hDlg, IDC_LIST_COLUMN), i, 1);
			SetFocus(GetDlgItem(hDlg, IDC_LIST_COLUMN));
			break;

		case IDC_BUTTON_SHOW:
			if ((i = ListView_GetNextItem(GetDlgItem(hDlg, IDC_LIST_COLUMN), -1, LVNI_SELECTED)) == -1) {
				break;
			}
			ListView_SetCheckState(GetDlgItem(hDlg, IDC_LIST_COLUMN), i, 1);
			SetFocus(GetDlgItem(hDlg, IDC_LIST_COLUMN));
			break;

		case IDC_BUTTON_HIDE:
			if ((i = ListView_GetNextItem(GetDlgItem(hDlg, IDC_LIST_COLUMN), -1, LVNI_SELECTED)) == -1) {
				break;
			}
			ListView_SetCheckState(GetDlgItem(hDlg, IDC_LIST_COLUMN), i, 0);
			SetFocus(GetDlgItem(hDlg, IDC_LIST_COLUMN));
			break;

		case IDOK:
			show_flag = FALSE;
			j = ListView_GetItemCount(GetDlgItem(hDlg, IDC_LIST_COLUMN));
			for (i = 0; i < j; i++) {
				if ((wk_hi = (HEADER_INFO *)listview_get_lparam(GetDlgItem(hDlg, IDC_LIST_COLUMN), i)) == NULL) {
					continue;
				}
				wk_hi->show = ListView_GetCheckState(GetDlgItem(hDlg, IDC_LIST_COLUMN), i);
				wk_hi->order = i;
				if (wk_hi->show == 1) {
					show_flag = TRUE;
				}
			}
			if (show_flag == FALSE) {
				for (i = 0; i < op.hi_count; i++) {
					if (op.hi[i].type == HDTP_NAME) {
						op.hi[i].show = 1;
						break;
					}
				}
			}
			EndDialog(hDlg, TRUE);
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/*
 * show_column - ݒʕ\
 */
BOOL show_column(const HINSTANCE hInst, const HWND hWnd)
{
	return DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_COLUMN), hWnd, column_proc, (LPARAM)0);
}
/* End of source */
