/*
 * n01_stats
 *
 * csv.h
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

#ifndef _INC_CSV_H
#define _INC_CSV_H

/* Include Files */

/* Define */
#define FILE_READ_COUNT				100

/* Struct */
typedef struct _CSV_SCORE_INFO {
	int first;
	int start_score;
	int round;
	int player;
	int darts;
	TYPE_SCORE *score;
	int *left;
} CSV_SCORE_INFO;

typedef struct _CSV_SCORE {
	CSV_SCORE_INFO *csvsi;
	int csvsi_count;
	int csvsi_size;
} CSV_SCORE;

/* Function Prototypes */
BOOL filelist_alloc(const int count);
int filelist_get_count(void);
BOOL filelist_create(const DATA_INFO *di, const int di_count);
void filelist_free(void);

int csv_read_file(DATA_INFO *di, const TCHAR *path, const TCHAR *filename, const int index);
BOOL csv_read(const TCHAR *path, const TCHAR *file, DATA_INFO **di, int *di_count, int *di_size);
BOOL csv_read_sync(const HWND hWnd, const TCHAR *path, DATA_INFO **di, int *di_count, int *di_size, int *cnt);
void csv_read_cancel(const BOOL flag);
int csv_find_index(const TCHAR *file, DATA_INFO *di, int di_count);
int csv_count(const TCHAR *path);
BOOL csv_score_read(const TCHAR *file_path, CSV_SCORE *csvs);
void csv_score_free(CSV_SCORE *csvs);
BOOL csv_write_header(const TCHAR *path, const TCHAR *filename, const DATA_INFO *di);
BOOL csv_write_list(const HWND lv_wnd, const TCHAR *file_name, const DATA_INFO *di, const int di_count);
HANDLE csv_copy_list(const HWND lv_wnd, const DATA_INFO *di, const int di_count);

#endif
/* End of source */
