/*
 * n01_stats
 *
 * delete.c
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <tchar.h>

#include "General.h"

#include "resource.h"

/* Define */

/* Global Variables */
extern OPTION op;

/* Local Function Prototypes */
static BOOL CALLBACK delete_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

/*
 * delete_proc - EBhEvV[W
 */
static BOOL CALLBACK delete_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	TCHAR buf[BUF_SIZE];
	TCHAR str[BUF_SIZE];
	RECT rect;

	switch (msg) {
	case WM_INITDIALOG:
		// Z^O
		GetWindowRect(hDlg, &rect);
		SetWindowPos(hDlg, 0,
			(GetSystemMetrics(SM_CXSCREEN) / 2) - ((rect.right - rect.left) / 2),
			(GetSystemMetrics(SM_CYSCREEN) / 2) - ((rect.bottom - rect.top) / 2),
			0, 0, SWP_NOSIZE | SWP_NOZORDER);
		// ACR\
		SendDlgItemMessage(hDlg, IDC_STATIC_ICON, STM_SETICON, (WPARAM)LoadIcon(NULL, (LPCTSTR)IDI_QUESTION), 0);
		// bZ[W\
		GetWindowText(GetDlgItem(hDlg, IDC_STATIC_MSG), buf, BUF_SIZE - 1);
		wsprintf(str, buf, lParam);
		SetWindowText(GetDlgItem(hDlg, IDC_STATIC_MSG), str);
		// 폜^Cvݒ
		switch (op.delete_type) {
		case 0:
		default:
			// ̃f[^̂ݍ폜
			SendDlgItemMessage(hDlg, IDC_RADIO_DELETE, BM_SETCHECK, 1, 0);
			break;
		case 1:
			// ֘Af[^ׂč폜
			SendDlgItemMessage(hDlg, IDC_RADIO_DELETE_ALL, BM_SETCHECK, 1, 0);
			break;
		case 2:
			// ֘Af[^ׂč폜 + CSVt@C폜
			SendDlgItemMessage(hDlg, IDC_RADIO_DELETE_ALL, BM_SETCHECK, 1, 0);
			SendDlgItemMessage(hDlg, IDC_CHECK_DELETE_CSV, BM_SETCHECK, 1, 0);
			break;
		}
		SendMessage(hDlg, WM_COMMAND, (WPARAM)IDC_RADIO_DELETE_ALL, 0);
		// Beep
		MessageBeep(MB_ICONQUESTION);
		break;

	case WM_CLOSE:

		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_RADIO_DELETE:
		case IDC_RADIO_DELETE_ALL:
			EnableWindow(GetDlgItem(hDlg, IDC_CHECK_DELETE_CSV), SendDlgItemMessage(hDlg, IDC_RADIO_DELETE_ALL, BM_GETCHECK, 0, 0));
			break;

		case IDOK:
			if (SendDlgItemMessage(hDlg, IDC_RADIO_DELETE, BM_GETCHECK, 0, 0) == 1) {
				op.delete_type = 0;
			} else if (SendDlgItemMessage(hDlg, IDC_RADIO_DELETE_ALL, BM_GETCHECK, 0, 0) == 1) {
				op.delete_type = 1;
				if (SendDlgItemMessage(hDlg, IDC_CHECK_DELETE_CSV, BM_GETCHECK, 0, 0) == 1) {
					op.delete_type = 2;
				}
			}
			EndDialog(hDlg, TRUE);
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/*
 * show_delete - 폜mFʕ\
 */
BOOL show_delete(const HINSTANCE hInst, const HWND hWnd, const int cnt)
{
	return DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_DELETE), hWnd, delete_proc, cnt);
}
/* End of source */
