/*
 * n01_stats
 *
 * general.h
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

#ifndef _INC_N01_STATS_GENERAL_H
#define _INC_N01_STATS_GENERAL_H

/* Include Files */
#include "n01_plugin.h"
#include "ListView.h"

/* Define */
#define APP_NAME					TEXT("n01_stats Ver 0.0.3")
#define APP_VERSION					3

#define WM_MAIN_REFRESH				(WM_APP + 100)
#define WM_MAIN_RELOAD_FILE			(WM_APP + 101)
#define WM_MAIN_GET_CSV_PATH		(WM_APP + 102)
#define WM_MAIN_SOCK_ERROR			(WM_APP + 103)
#define WM_MAIN_RELOAD_ALL			(WM_APP + 104)
#define WM_MAIN_RELOAD_STATUS		(WM_APP + 105)
#define WM_MAIN_UPDATE_ITEM			(WM_APP + 106)
#define WM_MAIN_RELOAD_ITEM			(WM_APP + 107)

#define FILE_NAME_SIZE				128
#define DATA_ALLOC_SIZE				100

#define INDEFINITE_CHAR				TEXT("")

#define DATA_STATUS_NONE			0
#define DATA_STATUS_DELETE			1

#define EXTRACT_TYPE_NAME			0
#define EXTRACT_TYPE_DATE			1
#define EXTRACT_TYPE_ALL			2

#define EXTRACT_SUB_TYPE_NONE		0
#define EXTRACT_SUB_TYPE_YEAR		1
#define EXTRACT_SUB_TYPE_MONTH		2
#define EXTRACT_SUB_TYPE_DAY		3
#define EXTRACT_SUB_TYPE_ALL		4

/* Struct */
// IvV
typedef struct _OPTION {
	RECT window_rect;
	int window_state;
	int sep_size;

	int lv_style;
	int lv_ex_style;
	int sort_colum;
	int sort_order;
	HEADER_INFO hi[MAX_HEADER];
	int hi_count;

	TCHAR csv_path[MAX_PATH];
	int csv_path_default;
	int csv_update;
	int delete_type;
	int extract_type;
	TCHAR split_sep[BUF_SIZE];
	int split_delete;
	int auto_split;
	TCHAR auto_split_sep[BUF_SIZE];
	int auto_split_delete;

	RECT score_list_rect;
	TCHAR score_list_font[BUF_SIZE];
} OPTION;

// v
typedef struct _DATA_INFO {
	// 
	short status;

	// O
	TCHAR name[NAME_SIZE];
	UINT name_hash;
	int vs_index;
	int index;
	// Jn
	SYSTEMTIME start_time;
	// t@C
	TCHAR file_name[FILE_NAME_SIZE];
	UINT file_name_hash;
	// JnXRA
	int start_score;

	// ZbgAbO
	int sets;
	int sets_play;
	int legs;
	int legs_play;

	// TON
	int ton_count;
	int ton00_count;
	int ton40_count;
	int ton80_count;
	TYPE_SCORE high_off;
	int short_game;
	int long_game;

	// _[c1{̕
	int all_score;
	int all_darts;
	// _[c̕
	int win_darts;
	int win_count;
	// 3Eh̕
	int first9_score;
	int first9_darts;
	// `FbNAEg
	int check_out_aim;
	int check_out;
	// UŏbO
	int all_keep_legs;
	int win_keep_legs;
	// UŏbO
	int all_break_legs;
	int win_break_legs;

	// Finish stats
	int success_2_80;
	int failure_2_80;
	int success_81_130;
	int failure_81_130;
	int success_131;
	int failure_131;
} DATA_INFO;

// o
typedef struct _EXTRACT_INFO {
	int sub_type;
	TCHAR name[NAME_SIZE];
	UINT name_hash;
	SYSTEMTIME date;

	// filter
	int filter_name_enable;
	TCHAR filter_name[BUF_SIZE];
	int filter_vs_name_enable;
	TCHAR filter_vs_name[BUF_SIZE];
	int filter_file_name_enable;
	TCHAR filter_file_name[BUF_SIZE];
	int filter_date_enable;
	int filter_time_enable;
	SYSTEMTIME filter_date_st;
	SYSTEMTIME filter_date_en;
	int filter_start_score_enable;
	int filter_start_score;
} EXTRACT_INFO;

// O
typedef struct _NAME_INFO {
	TCHAR name[NAME_SIZE];
	UINT name_hash;
} NAME_INFO;

/* Function Prototypes */
void do_events(const HWND hWnd);

#endif
/* End of source */

