/*
 * n01_stats
 *
 * index.c
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef	_INC_OLE

#include "general.h"
#include "Memory.h"
#include "file.h"

/* Define */

/* Global Variables */

/* Local Function Prototypes */

/*
 * index_save - CfbNXۑ
 */
BOOL index_save(const TCHAR *file_name, const DATA_INFO *di, const int st, const int en)
{
	HANDLE hFile;
	DWORD ret;
	WORD dsize;

	if (st == en) {
		return TRUE;
	}
	// t@CJ
	hFile = CreateFile(file_name, GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == NULL || hFile == (HANDLE)-1) {
		return FALSE;
	}
	if (st == 0) {
		// f[^TCY̏
		dsize = sizeof(DATA_INFO);
		if (WriteFile(hFile, &dsize, sizeof(WORD), &ret, NULL) == FALSE) {
			CloseHandle(hFile);
			return FALSE;
		}
	}
	// ǉʒu̎擾
	if (SetFilePointer(hFile, sizeof(WORD) + (sizeof(DATA_INFO) * st), NULL, FILE_BEGIN) == 0xFFFFFFFF) {
		CloseHandle(hFile);
		return FALSE;
	}
	// f[^̏
	if (WriteFile(hFile, di + st, sizeof(DATA_INFO) * (en - st), &ret, NULL) == FALSE) {
		CloseHandle(hFile);
		return FALSE;
	}
	CloseHandle(hFile);
	return TRUE;
}

/*
 * index_load - CfbNX̓ǂݍ
 */
BOOL index_load(const HWND hWnd, const TCHAR *file_name, DATA_INFO **di, int *di_count, int *di_size)
{
	HANDLE hFile;
	DWORD size;
	WORD dsize;
	DWORD ret;

	// t@CTCY擾
	size = file_get_size(file_name);
	if (size == -1) {
		return FALSE;
	}
	if (size < sizeof(WORD)) {
		return FALSE;
	}
	// t@CJ
	hFile = CreateFile(file_name, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == NULL || hFile == (HANDLE)-1) {
		return FALSE;
	}
	// f[^TCY擾
	if (ReadFile(hFile, &dsize, sizeof(WORD), &ret, NULL) == FALSE) {
		CloseHandle(hFile);
		return FALSE;
	}
	if (dsize != sizeof(DATA_INFO)) {
		CloseHandle(hFile);
		return FALSE;
	}
	size -= sizeof(WORD);
	if ((size % sizeof(DATA_INFO)) != 0) {
		CloseHandle(hFile);
		return FALSE;
	}
	// f[^ǂݍ
	*di_count = size / sizeof(DATA_INFO);
	*di_size = *di_count + DATA_ALLOC_SIZE;
	*di = mem_alloc(sizeof(DATA_INFO) * (*di_size));
	if (*di == NULL) {
		CloseHandle(hFile);
		*di_count = *di_size = 0;
		return FALSE;
	}
	if (ReadFile(hFile, *di, size, &ret, NULL) == FALSE) {
		CloseHandle(hFile);
		mem_free(&(*di));
		*di_count = *di_size = 0;
		return FALSE;
	}
	CloseHandle(hFile);
	return TRUE;
}
/* End of source */
